package whoop

import "golang.org/x/oauth2"

type OauthConfig struct {
	WhoopLoginConfig oauth2.Config
}

var oauthConfig *OauthConfig

func ProvideWhoopConfig(conf *Config) (*OauthConfig, error) {
	if oauthConfig == nil {
		oauthConfig = &OauthConfig{
			WhoopLoginConfig: oauth2.Config{
				RedirectURL:  "http://localhost:8080/oauth2/callback",
				ClientID:     conf.WhoopClientID,
				ClientSecret: conf.WhoopClientSecret,
				Endpoint: oauth2.Endpoint{
					AuthURL:  conf.WhoopAuthURL,
					TokenURL: conf.WhoopTokenURL,
					AuthStyle: oauth2.AuthStyleInParams,
				},
				Scopes: []string{
					"offline",
					"read:recovery",
					"read:cycles",
					"read:workout",
					"read:sleep",
					"read:profile",
					"read:body_measurement",
				},
			},
		}
	}

	return oauthConfig, nil
}
